



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【node.js】readline (逐行读取)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【node.js】readline (逐行读取)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-18 07:27:31 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>官网链接：<a href="http://nodejs.cn/api/readline#readline_readline" rel="external nofollow noreferrer">http://nodejs.cn/api/readline#readline_readline</a></p>
<p><strong><code>require('readline')</code>&nbsp;模块</strong>提供了一个接口，用于从<a href="http://nodejs.cn/api/stream.html#stream_readable_streams" rel="external nofollow noreferrer">可读流</a>（如&nbsp;<a href="http://nodejs.cn/api/process.html#process_process_stdin" rel="external nofollow noreferrer"><code>process.stdin</code></a>）读取数据，每次读取一行。 它可以通过以下方式使用：</p>
<div>
<pre class="prettyprint linenums">const readline = require('readline');</pre>
</div>
<p>例子，<code>readline</code>&nbsp;模块的基本用法：</p>
<div>
<pre class="prettyprint linenums">const readline = require('readline');

const rl = readline.createInterface({<br />
  input: process.stdin,<br />
  output: process.stdout<br />
});

rl.question('你认为 Node.js 中文网怎么样？', (answer) =&gt; {<br />
  // 对答案进行处理<br />
  console.log(`多谢你的反馈：${answer}`);

  rl.close();<br />
});</pre>
</div>
<p><strong>Interface 类</strong></p>
<p><code>readline.Interface</code>&nbsp;类的实例是使用&nbsp;<code>readline.createInterface()</code>&nbsp;方法构造的。 每个实例都关联一个&nbsp;<code>input</code>&nbsp;<a href="http://nodejs.cn/api/stream.html#stream_readable_streams" rel="external nofollow noreferrer">可读流</a>和一个&nbsp;<code>output</code>&nbsp;<a href="http://nodejs.cn/api/stream.html#stream_writable_streams" rel="external nofollow noreferrer">可写流</a>。&nbsp;<code>output</code>&nbsp;流用于为到达的用户输入打印提示，且从&nbsp;<code>input</code>&nbsp;流读取。</p>
<h3>'line' 事件</h3>
<p>每当&nbsp;<code>input</code>&nbsp;流接收到接收<strong>行结束符</strong>（<code>\n</code>、<code>\r</code>&nbsp;或&nbsp;<code>\r\n</code>）时触发&nbsp;<code>'line'</code>&nbsp;事件。 通常发生在用户按下&nbsp;<code>&lt;Enter&gt;</code>&nbsp;键或<code>&lt;Return&gt;</code>&nbsp;键。监听器函数被调用时会带上一个包含接收的那一行输入的字符串。</p>
<div>
<pre class="prettyprint linenums">rl.on('line', (input) =&gt; {<br />
  console.log(`接收到：${input}`);<br />
});</pre>
</div>
<h3>rl.question(query, callback)</h3>
<div>
<pre class="prettyprint linenums">rl.question('你最喜欢的食物是什么？ ', (answer) =&gt; {<br />
  console.log(`你最喜欢的食物是 ${answer}`);<br />
});</pre>
</div>
<h2>例子：逐行地读取文件流</h2>
<p>从一个文件系统<a href="http://nodejs.cn/api/stream.html#stream_readable_streams" rel="external nofollow noreferrer">可读流</a>中每次一行地消耗输入：</p>
<div>
<pre class="prettyprint linenums">const readline = require('readline');<br />
const fs = require('fs');

const rl = readline.createInterface({<br />
  input: fs.createReadStream('sample.txt')<br />
});

rl.on('line', (line) =&gt; {<br />
  console.log(`文件的单行内容：${line}`);<br />
});</pre>
</div>
<p><strong>&nbsp;使用readline模块实现Node.js的输入输出</strong></p>
<p><strong>参考:<a href="http://blog.csdn.net/zgljl2012/article/details/48321171" rel="external nofollow noreferrer">http://blog.csdn.net/zgljl2012/article/details/48321171</a></strong></p>
<p>创建Readline实例、学习里面的接口方法、学习监听与处理Readline事件</p>
<h3>实例1：我叫小明</h3>
<div>
<pre class="prettyprint linenums">// 引入readline模块<br />
var readline = require('readline');

//创建readline接口实例<br />
var  rl = readline.createInterface({<br />
    input:process.stdin,<br />
    output:process.stdout<br />
});

// question方法<br />
rl.question("你叫什么？",function(answer){<br />
    console.log("名字是："+answer);<br />
    // 不加close，则不会结束<br />
    rl.close();<br />
});

// close事件监听<br />
rl.on("close", function(){<br />
   // 结束程序<br />
    process.exit(0);<br />
});</pre>
</div>
<p>首先使用了createInterface创建了一个接口实例，然后使用了question方法来询问姓名，最后是监听readline的close事件，因为无论是方法名和事件的监听的名字都比较直观，关于它们的作用也能一目了然，我这里就只提了三点需要注意的：</p>
<p>1）在createInterface里，我们需要传入标准输入输出作为数据的输入输出流</p>
<p>2）在question方法的回调函数里，我们可以获取到用户的输入并进行处理，同时我们进行了close操作来结束程序，否则程序不会结束</p>
<p>3）在close事件的监听里，我们执行了process.exit(0)来使程序退出的操作，<strong>因为readline模块只要一开始获取用户输入就不会结束，必须使用这种直接的方式来结束程序</strong></p>
<h3>实例2：输入与输出</h3>
<div>
<pre class="prettyprint linenums">// 引入readline模块<br />
var readline = require('readline');

var rl = readline.createInterface({<br />
    input: process.stdin,<br />
    output: process.stdout<br />
});

rl.on('line', function(line){<br />
    switch(line.trim()) {<br />
        case 'copy':<br />
            console.log("复制");<br />
            break;<br />
        case 'hello':<br />
            rl.write("Write");<br />
            console.log('world!');<br />
            break;<br />
        case 'close':<br />
            rl.close();<br />
            break;<br />
        default:<br />
            console.log('没有找到命令！');<br />
            break;<br />
    }<br />
});<br />
rl.on('close', function() {<br />
    console.log('bye bye');<br />
    process.exit(0);<br />
});</pre>
</div>
<p>&lsquo;line&rsquo;事件，这个事件就是在<strong>用户输完一行，按下回车后</strong>就会触发的事件，它会将用户输入的数据通过回调函数传回来，可在此方法里处理用户输入的数据。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49gp25l9.html">TortoiseGit的使用教程（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4n4ee9.html">ROS学习笔记（一）&mdash;&mdash;软件版本的选择</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvplr1q.html">No configuration found for the specified action解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r2gveq.html">六、通过插件如何创建自己的MEL command</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okkxe59.html">纯JS省市区三级联动</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ywgojq.html">&lbrack;转载&rsqb;常用Web Service汇总（天气预报、时刻表等）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnv11pq.html">wpa&lowbar;supplicant对wep&comma;wpa&comma;wpa2的psk和隐藏ap的scan&lowbar;ssid扫描配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvwzm1q.html">asterisk 能打电话的配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z0v529.html">Bootstrap的响应式&comma;当文字超过div长度&comma;换行问题的处理&excl;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wom73q.html">USB系列之四：向U盘上写数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mpoy1q.html">利用sass构建组件化的ui库</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj16ox9.html">PAT 团体程序设计天梯赛-练习集 L2-003&period; 月饼</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zdo1j9.html">Python 装饰器总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pn7n48.html">Java 反射详解  转载</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jk0p3q.html">【原创 Hadoop&amp;amp&semi;Spark 动手实践 3】Hadoop2&period;7&period;3 MapReduce理论与动手实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdygrv9.html">用 python 生成一个简单的词云图</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy2kjd9.html">memcache、redis原理对比</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5om34q.html">jvm的内存分配</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjewdr8.html">&period;NET：Attribute 入门（内训教程）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9530vov8.html">一个简易的WebServer程序</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qyv6vpdq.html">fzu 2139  久违的月赛之二</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7e2nwk9.html">Collection FrameWork</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1wvle9.html">FineReport中如何用JavaScript自定义地图标签</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnngwv3q.html">地图经纬度坐标与屏幕坐标的转换&lpar;android版&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8em33wk9.html">import依赖范围的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/953zn3z8.html">leetCode题解之删除单链表中指定的元素</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1wxne9.html">Web程序中打开QQ、邮箱、阿里旺旺等</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnngl23q.html">clean-css</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7e2j3j9.html">&lbrack;转载&rsqb;Cool&comma; Tomcat is able to handle more than 13&comma;000 concurrent connections</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjyzer8.html">Oracle EBS 报表日期格式问题</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
